assert(juggy, "Juggy_Definitions.lua must be defined first.")

-- we define this function in SRB2 only for optimization purposes
juggy.GetCharColorFromVMAP = nil;

if MODID == juggy.SRB2 then -- SRB2
    juggy.GetCharColorFromVMAP = function(vmap)
        -- You'd really really think this should be a base game function but it isn't :ghost:
        if vmap == V_MAGENTAMAP then
            return "\x81"
        elseif vmap == V_YELLOWMAP then
            return "\x82"
        elseif vmap == V_GREENMAP then
            return "\x83"
        elseif vmap == V_BLUEMAP then
            return "\x84"
        elseif vmap == V_REDMAP then
            return "\x85"--
        elseif vmap == V_GRAYMAP then
            return "\x86"
        elseif vmap == V_ORANGEMAP then
            return "\x87"
        elseif vmap == V_SKYMAP then
            return "\x88"
        elseif vmap == V_PURPLEMAP then
            return "\x89"
        elseif vmap == V_AQUAMAP then
            return "\x8a"
        elseif vmap == V_PERIDOTMAP then
            return "\x8b"
        elseif vmap == V_AZUREMAP then
            return "\x8c"
        elseif vmap == V_BROWNMAP then
            return "\x8d"
        elseif vmap == V_ROSYMAP then
            return "\x8e"
        elseif vmap == V_INVERTMAP then
            return "\x8f"
        end

        return "\x80"

    end
end

juggy.chatColorsTable = {}
juggy.colorNamesTable = {}

-- ditto but for kart
if MODID == juggy.SRB2KART then -- SRB2Kart
    juggy.chatColorsTable =
    {
        -- Expanded for custom client colors
		[SKINCOLOR_WHITE] = "\x80",
		[SKINCOLOR_SILVER] = "\x80",
		[77] = "\x80",
		[101] = "\x80",
		[104] = "\x80",
		[131] = "\x80",
		[184] = "\x80",
		[189] = "\x80",
		[90] = "\x81",
		[93] = "\x81",
		[94] = "\x81",
		[125] = "\x81",
		[126] = "\x81",
		[127] = "\x81",
		[197] = "\x81",
		[198] = "\x81",
		[200] = "\x81",
		[203] = "\x81",
		[SKINCOLOR_POPCORN] = "\x82",
		[SKINCOLOR_QUARRY] = "\x82",
		[SKINCOLOR_YELLOW] = "\x82",
		[SKINCOLOR_MUSTARD] = "\x82",
		[SKINCOLOR_CROCODILE] = "\x82",
		[SKINCOLOR_OLIVE] = "\x82",
		[114] = "\x82",
		[154] = "\x82",
		[185] = "\x82",
		[SKINCOLOR_LIME] = "\x83",
		[SKINCOLOR_HANDHELD] = "\x83",
		[SKINCOLOR_MOSS] = "\x83",
		[SKINCOLOR_CAMOUFLAGE] = "\x83",
		[SKINCOLOR_ROBOHOOD] = "\x83",
		[SKINCOLOR_MINT] = "\x83",
		[SKINCOLOR_GREEN] = "\x83",
		[SKINCOLOR_PINETREE] = "\x83",
		[67] = "\x83",
		[66] = "\x83",
		[SKINCOLOR_EMERALD] = "\x83",
		[SKINCOLOR_SWAMP] = "\x83",
		[SKINCOLOR_DREAM] = "\x83",
		[119] = "\x83",
		[155] = "\x83",
		[156] = "\x83",
		[159] = "\x83",
		[160] = "\x83",
		[162] = "\x83",
		[164] = "\x83",
		[165] = "\x83",
		[166] = "\x83",
		[168] = "\x83",
		[169] = "\x83",
		[179] = "\x83",
		[84] = "\x84",
		[85] = "\x84",
		[86] = "\x84",
		[87] = "\x84",
		[123] = "\x84",
		[124] = "\x84",
		[172] = "\x84",
		[174] = "\x84",
		[180] = "\x84",
		[181] = "\x84",
		[188] = "\x84",
		[191] = "\x84",
		[SKINCOLOR_CINNAMON] = "\x85",
		[SKINCOLOR_RUBY] = "\x85",
		[SKINCOLOR_RASPBERRY] = "\x85",
		[SKINCOLOR_CHERRY] = "\x85",
		[SKINCOLOR_RED] = "\x85",
		[SKINCOLOR_CRIMSON] = "\x85",
		[SKINCOLOR_MAROON] = "\x85",
		[SKINCOLOR_FLAME] = "\x85",
		[SKINCOLOR_SCARLET] = "\x85",
		[SKINCOLOR_KETCHUP] = "\x85",
		[137] = "\x85",
		[138] = "\x85",
		[139] = "\x85",
		[140] = "\x85",
		[202] = "\x85",
		[SKINCOLOR_GREY] = "\x86",
		[SKINCOLOR_NICKEL] = "\x86",
		[SKINCOLOR_BLACK] = "\x86",
		[SKINCOLOR_SKUNK] = "\x86",
		[SKINCOLOR_JET] = "\x86",
		[102] = "\x86",
		[103] = "\x86",
		[132] = "\x86",
		[SKINCOLOR_DAWN] = "\x87",
		[SKINCOLOR_SUNSET] = "\x87",
		[SKINCOLOR_CREAMSICLE] = "\x87",
		[SKINCOLOR_ORANGE] = "\x87",
		[SKINCOLOR_PUMPKIN] = "\x87",
		[SKINCOLOR_ROSEWOOD] = "\x87",
		[SKINCOLOR_BURGUNDY] = "\x87",
		[SKINCOLOR_TANGERINE] = "\x87",
		[112] = "\x87",
		[141] = "\x87",
		[149] = "\x87",
		[68] = "\x88",
		[69] = "\x88",
		[70] = "\x88",
		[71] = "\x88",
		[72] = "\x88",
		[73] = "\x88",
		[74] = "\x88",
		[75] = "\x88",
		[83] = "\x88",
		[120] = "\x88",
		[121] = "\x88",
		[122] = "\x88",
		[167] = "\x88",
		[171] = "\x88",
		[173] = "\x88",
		[175] = "\x88",
		[176] = "\x88",
		[177] = "\x88",
		[178] = "\x88",
		[192] = "\x88",
		[88] = "\x89",
		[89] = "\x89",
		[91] = "\x89",
		[95] = "\x89",
		[96] = "\x89",
		[97] = "\x89",
		[98] = "\x89",
		[99] = "\x89",
		[128] = "\x89",
		[147] = "\x89",
		[193] = "\x89",
		[194] = "\x89",
		[195] = "\x89",
		[SKINCOLOR_GOLD] = "\x8A",
		[SKINCOLOR_ROYAL] = "\x8A",
		[SKINCOLOR_BRONZE] = "\x8A",
		[SKINCOLOR_COPPER] = "\x8A",
		[79] = "\x8A",
		[111] = "\x8A",
		[113] = "\x8A",
		[142] = "\x8A",
		[143] = "\x8A",
		[144] = "\x8A",
		[153] = "\x8A",
		[SKINCOLOR_ARTICHOKE] = "\x8B",
		[SKINCOLOR_VOMIT] = "\x8B",
		[SKINCOLOR_GARDEN] = "\x8B",
		[SKINCOLOR_TEA] = "\x8B",
		[SKINCOLOR_PISTACHIO] = "\x8B",
		[115] = "\x8B",
		[116] = "\x8B",
		[117] = "\x8B",
		[118] = "\x8B",
		[150] = "\x8B",
		[157] = "\x8B",
		[158] = "\x8B",
		[161] = "\x8B",
		[163] = "\x8B",
		[170] = "\x8B",
		[SKINCOLOR_PIGEON] = "\x8C",
		[76] = "\x8C",
		[78] = "\x8C",
		[105] = "\x8C",
		[106] = "\x8C",
		[182] = "\x8C",
		[186] = "\x8C",
		[187] = "\x8C",
		[190] = "\x8C",
		[196] = "\x8C",
		[204] = "\x8C",
		[SKINCOLOR_FAIRY] = "\x8D",
		[SKINCOLOR_SALMON] = "\x8D",
		[SKINCOLOR_PINK] = "\x8D",
		[SKINCOLOR_ROSE] = "\x8D",
		[SKINCOLOR_BRICK] = "\x8D",
		[SKINCOLOR_LEMONADE] = "\x8D",
		[92] = "\x8D",
		[100] = "\x8D",
		[129] = "\x8D",
		[130] = "\x8D",
		[134] = "\x8D",
		[135] = "\x8D",
		[136] = "\x8D",
		[145] = "\x8D",
		[146] = "\x8D",
		[199] = "\x8D",
		[201] = "\x8D",
		[SKINCOLOR_SEPIA] = "\x8E",	
		[SKINCOLOR_BEIGE] = "\x8E",	
		[SKINCOLOR_WALNUT] = "\x8E",
		[SKINCOLOR_BROWN] = "\x8E",	
		[SKINCOLOR_LEATHER] = "\x8E",
		[80] = "\x8E",
		[81] = "\x8E",
		[107] = "\x8E",
		[108] = "\x8E",
		[133] = "\x8E",
		[148] = "\x8E",
		[151] = "\x8E",
		[152] = "\x8E",
		[SKINCOLOR_PEACH] = "\x8F",
		[SKINCOLOR_CARAMEL] = "\x8F",
		[SKINCOLOR_CREAM] = "\x8F",
		[109] = "\x8F",
		[110] = "\x8F",
		[183] = "\x8F",
    }

    juggy.colorNamesTable =
    {
        -- Have I mentioned there is zero color support in Kart?
        ["white"] = SKINCOLOR_WHITE,
        ["silver"] = SKINCOLOR_SILVER,
        ["slate"] = SKINCOLOR_SLATE,	
        ["ultraviolet"] = SKINCOLOR_ULTRAVIOLET,
        ["purple"] = SKINCOLOR_PURPLE,
        ["fuchsia"] = SKINCOLOR_FUCHSIA,
        ["popcorn"] = SKINCOLOR_POPCORN,
        ["quarry"] = SKINCOLOR_QUARRY,
        ["yellow"] = SKINCOLOR_YELLOW,
        ["mustard"] = SKINCOLOR_MUSTARD,
        ["crocodile"] = SKINCOLOR_CROCODILE,
        ["olive"] = SKINCOLOR_OLIVE,
        ["lime"] = SKINCOLOR_LIME,
        ["handheld"] = SKINCOLOR_HANDHELD,
        ["moss"] = SKINCOLOR_MOSS,
        ["camouflage"] = SKINCOLOR_CAMOUFLAGE,
        ["robohood"] = SKINCOLOR_ROBOHOOD,
        ["mint"] = SKINCOLOR_MINT,
        ["green"] = SKINCOLOR_GREEN,
        ["pinetree"] = SKINCOLOR_PINETREE,
        ["algae"] = SKINCOLOR_ALGAE,
        ["plague"] = SKINCOLOR_PLAGUE,
        ["emerald"] = SKINCOLOR_EMERALD,
        ["swamp"] = SKINCOLOR_SWAMP,
        ["dream"] = SKINCOLOR_DREAM,	
        ["periwinkle"] = SKINCOLOR_PERIWINKLE,
        ["blue"] = SKINCOLOR_BLUE,
        ["blueberry"] = SKINCOLOR_BLUEBERRY,
        ["nova"] = SKINCOLOR_NOVA,	
        ["cinnamon"] = SKINCOLOR_CINNAMON,
        ["ruby"] = SKINCOLOR_RUBY,
        ["raspberry"] = SKINCOLOR_RASPBERRY,
        ["cherry"] = SKINCOLOR_CHERRY,
        ["red"] = SKINCOLOR_RED,
        ["crimson"] = SKINCOLOR_CRIMSON,
        ["maroon"] = SKINCOLOR_MAROON,
        ["flame"] = SKINCOLOR_FLAME,
        ["scarlet"] = SKINCOLOR_SCARLET,
        ["ketchup"] = SKINCOLOR_KETCHUP,
        ["grey"] = SKINCOLOR_GREY,
        ["nickel"] = SKINCOLOR_NICKEL,
        ["black"] = SKINCOLOR_BLACK,
        ["skunk"] = SKINCOLOR_SKUNK,
        ["jet"] = SKINCOLOR_JET,	
        ["dawn"] = SKINCOLOR_DAWN,
        ["sunset"] = SKINCOLOR_SUNSET,
        ["creamsicle"] = SKINCOLOR_CREAMSICLE,
        ["orange"] = SKINCOLOR_ORANGE,
        ["pumpkin"] = SKINCOLOR_PUMPKIN,
        ["rosewood"] = SKINCOLOR_ROSEWOOD,
        ["burgundy"] = SKINCOLOR_BURGUNDY,
        ["tangerine"] = SKINCOLOR_TANGERINE,	
        ["caribbean"] = SKINCOLOR_CARIBBEAN,
        ["azure"] = SKINCOLOR_AZURE,
        ["aqua"] = SKINCOLOR_AQUA,
        ["teal"] = SKINCOLOR_TEAL,
        ["cyan"] = SKINCOLOR_CYAN,
        ["jawz"] = SKINCOLOR_JAWZ,
        ["cerulean"] = SKINCOLOR_CERULEAN,
        ["navy"] = SKINCOLOR_NAVY,
        ["sapphire"] = SKINCOLOR_SAPPHIRE,
        ["pastel"] = SKINCOLOR_PASTEL,
        ["moonslam"] = SKINCOLOR_MOONSLAM,
        ["dusk"] = SKINCOLOR_DUSK,
        ["toxic"] = SKINCOLOR_TOXIC,
        ["mauve"] = SKINCOLOR_MAUVE,
        ["lavender"] = SKINCOLOR_LAVENDER,
        ["byzantium"] = SKINCOLOR_BYZANTIUM,
        ["pomegranate"] = SKINCOLOR_POMEGRANATE,
        ["gold"] = SKINCOLOR_GOLD,
        ["royal"] = SKINCOLOR_ROYAL,
        ["bronze"] = SKINCOLOR_BRONZE,
        ["copper"] = SKINCOLOR_COPPER,
        ["thunder"] = SKINCOLOR_THUNDER,
        ["artichoke"] = SKINCOLOR_ARTICHOKE,
        ["vomit"] = SKINCOLOR_VOMIT,
        ["garden"] = SKINCOLOR_GARDEN,
        ["tea"] = SKINCOLOR_TEA,
        ["pistachio"] = SKINCOLOR_PISTACHIO,	
        ["pigeon"] = SKINCOLOR_PIGEON,
        ["platinum"] = SKINCOLOR_PLATINUM,
        ["steel"] = SKINCOLOR_STEEL,
        ["fairy"] = SKINCOLOR_FAIRY,
        ["salmon"] = SKINCOLOR_SALMON,
        ["pink"] = SKINCOLOR_PINK,
        ["rose"] = SKINCOLOR_ROSE,
        ["brink"] = SKINCOLOR_BRICK,
        ["lemonade"] = SKINCOLOR_LEMONADE,
        ["bubblegum"] = SKINCOLOR_BUBBLEGUM,
        ["lilac"] = SKINCOLOR_LILAC,	
        ["sepia"] = SKINCOLOR_SEPIA,	
        ["beige"] = SKINCOLOR_BEIGE,	
        ["walnut"] = SKINCOLOR_WALNUT,
        ["brown"] = SKINCOLOR_BROWN,	
        ["leather"] = SKINCOLOR_LEATHER,
        ["rust"] = SKINCOLOR_RUST,
        ["wristwatch"] = SKINCOLOR_WRISTWATCH,
        ["peach"] = SKINCOLOR_PEACH,
        ["caramel"] = SKINCOLOR_CARAMEL,
        ["cream"] = SKINCOLOR_CREAM,
    }
end

juggy.GetChatColorFromSkinColor = function(skincolor)

    if skincolor == nil then return "\x80" end
    
    if MODID == juggy.SRB2 then -- SRB2
        return juggy.GetCharColorFromVMAP(skincolors[skincolor].chatcolor) or "\x80"
    else -- SRB2Kart
        return juggy.chatColorsTable[skincolor]
    end

    -- return 
end